
//     LCD Nokia 1202
//
//
 #include "font.h"
void LCD_CMD (unsigned char i);					//    LCD
void LCD_DATA (unsigned char i);				//    LCD
void LCD_INIT (void);						//    LCD
void LCD_CLR (void);						//  LCD
void LCD_POS (unsigned char row, unsigned char col); // y  0  7, x  0  96.     0,0             y  8													
void LCD_CHAR (unsigned char c);				//   5  8
void LCD_CHAR_12x16(unsigned char row, unsigned char col,unsigned char c);

#define CLK_CLR	   P1OUT &=~ BIT2;    // P1.2 CLK clear
#define CLK_SET	   P1OUT |= BIT2;     // P1.2 CLK set
#define DATA_CLR   P1OUT &=~ BIT1;    // P1.1 DATA clear
#define DATA_SET   P1OUT |= BIT1;     // P1.1 DATA set
#define CS_CLR     P1OUT &=~ BIT0;      // P1.0 CS clear
#define CS_SET     P1OUT |= BIT0;       // P1.0 CS set


//========================================================================
//  6 
void delay (void){
	unsigned int a, c;	
	for (a=0; a<100; a++){
	c++;	
	}	
} // delay
//=========================================================================
void LCD_CMD (unsigned char i){
	unsigned char d,c;
	  CLK_CLR     //  CLK clear
	  CS_CLR      // CS clear
	  DATA_CLR    //  SDA clear
	  CLK_SET     //  CLK  set
	  CLK_CLR     //  CLK clear
	for (c=0; c<8; c++){
	d = i & 0x80;
	if (d == 0)   DATA_CLR   // SDA clear
	else   DATA_SET    // SDA set
	  CLK_SET    //  CLK  set
	  CLK_CLR    //  CLK clear
	i = i << 1;
	} // for

} // LCD_CMD
//=============================================================
void LCD_DATA (unsigned char i){
	unsigned char d,c;

	  CLK_CLR    //  CLK clear
	  CS_CLR      // CS clear
	  DATA_SET    // SDA set
	  CLK_SET    //  CLK  set
	  CLK_CLR    //  CLK clear

	for (c=0; c<8; c++){
	d = i & 0x80;
	if (d == 0)   DATA_CLR    //  SDA clear
	else   DATA_SET    // SDA set
	  CLK_SET    //  CLK  set
	  CLK_CLR    //  CLK clear
	i = i << 1;
	} // for

}  // LCD_DATA

//=============================================================

 void LCD_INIT (void){
	CS_SET    // CS set
	  CLK_CLR    //  CLK clear
//	delay();
//	delay();
	LCD_CMD(0xE2); // Reset
	CS_SET    // CS set 
//	delay();
//	delay();
    LCD_CMD(0xA4); // Power saver off
	CS_SET    // CS set 
//	delay();
//----------------------------------------
	LCD_CMD(0xA6); // Normal DRAM
	CS_SET    // CS set 
	LCD_CMD(0xA4); // Normal mode
	CS_SET    // CS set 
	LCD_CMD(0xA0); // Col normal
	CS_SET    // CS set 
	LCD_CMD(0xC0); // driver normal
	CS_SET    // CS set 
	LCD_CMD(0x24); // VOR def
	CS_SET    // CS set 
//--------
	LCD_CMD(0xE1); // Contrast
	LCD_CMD(0x80); // def
	CS_SET    // CS set 
//-------
	LCD_CMD(0x90); // El vol - def
	CS_SET    // CS set 

//-----------------------------------------
    LCD_CMD(0x2F); // Power control set
	CS_SET    // CS set 
    LCD_CMD(0xAF); // LCD display on
	CS_SET    // CS set 
	LCD_CLR();
	LCD_POS (0,0);
	CS_SET    // CS set 
} // LCD_INIT
//=================================================

void LCD_CLR (void){
  int i;
 	LCD_CMD(0xB0); // Page address set
	CS_SET    // CS set
    LCD_CMD(0x10); // Colum address set
    LCD_CMD(0x00);
	CS_SET    // CS set 	
    for(i=0; i<864; i++)
    {
        LCD_DATA(0);
    }
	CS_SET    // CS set 
} // LCD_CLR

//=====================================================

void LCD_POS (unsigned char row, unsigned char col){

	LCD_CMD(0xB0 | (row & 0x0F)); // Page address set
	CS_SET    // CS set 
  	LCD_CMD(0x10 | (col>>4)); // Sets the DDRAM column address - upper 3-bit
        LCD_CMD(0x00 | (col & 0x0F)); // lower 4-bit
	CS_SET    // CS set 
} // LCD_POS

//=======================================================

void LCD_CHAR (unsigned char c){
	unsigned char line;
	unsigned char ch;
        const char* f;
        f = (font6_8[c]);

	for(line=0;line<6;line++)
	{
		ch = *f++;
        LCD_DATA(ch);
	}
	CS_SET    // CS set 
} // LCD_CHAR

//=========================================================



//=========================================================
// LCD_CHAR_12x16(0,0,'1') 0,0     
//     80  
//  4   y  
//                                y                   x          
void LCD_CHAR_12x16(unsigned char row, unsigned char col, unsigned char c){


    unsigned char i;
    unsigned char BC[6];
    unsigned char DC[6];  
    
for (i=0;i<6;i++)
{ 
if (((font6_8[c][i])&BIT0)>0) {BC[i] |=BIT0;BC[i] |=BIT1;} else {BC[i] &=~ BIT0 ;BC[i] &=~ BIT1 ;}
if (((font6_8[c][i])&BIT1)>0) {BC[i] |=BIT2;BC[i] |=BIT3;} else {BC[i] &=~ BIT2 ;BC[i] &=~ BIT3 ;}
if (((font6_8[c][i])&BIT2)>0) {BC[i] |=BIT4;BC[i] |=BIT5;} else {BC[i] &=~ BIT4 ;BC[i] &=~ BIT5 ;}
if (((font6_8[c][i])&BIT3)>0) {BC[i] |=BIT6;BC[i] |=BIT7;} else {BC[i] &=~ BIT6 ;BC[i] &=~ BIT7 ;}
if (((font6_8[c][i])&BIT4)>0) {DC[i] |=BIT0;DC[i] |=BIT1;} else {DC[i] &=~ BIT0 ;DC[i] &=~ BIT1 ;}
if (((font6_8[c][i])&BIT5)>0) {DC[i] |=BIT2;DC[i] |=BIT3;} else {DC[i] &=~ BIT2 ;DC[i] &=~ BIT3 ;}
if (((font6_8[c][i])&BIT6)>0) {DC[i] |=BIT4;DC[i] |=BIT5;} else {DC[i] &=~ BIT4 ;DC[i] &=~ BIT5 ;}
if (((font6_8[c][i])&BIT7)>0) {DC[i] |=BIT6;DC[i] |=BIT7;} else {DC[i] &=~ BIT6 ;DC[i] &=~ BIT7 ;}
}
   
   LCD_POS(row,col);
   for (i=0;i<6;i++)   //   
   {
     LCD_DATA(BC[i]);
     LCD_DATA(BC[i]);   
   };
   LCD_POS(row+1,col);
   for (i=0;i<6;i++)   //   
   {
     LCD_DATA(DC[i]);
     LCD_DATA(DC[i]);   
   };

	CS_SET    // CS set
}

//==========================================================


